package model;

import tests.Node;

public class ListUtilities<E> { 
	public Node<E> shiftedToRightBy(Node<E> head, int n) {
		int size = 0;
		Node<E> current = head;
		Node<E> tail = null;
		
		while(current != null) {
			size ++;
			tail = current;
			current = current.getNext();
		}
		
		if(size == 0) {
			return null;
		}
		else { // at least one nodes are in the input chain
			int nos = n % size; /* number of shifts */
			int shiftStartsAt = size - nos - 1;
			
			if(n == 0 || nos == 0) { /* nos == 0 means n is a multiple of size */
				return head;
			}
			else { /* there's at least one shift to do */ 
				current = head;
				/* travel to the position where the shift starts */
				for(int i = 0; i < shiftStartsAt; i ++) { /* what if: i <= shiftStartsAt? */ 
					current = current.getNext();
				}
				// Exiting from the loop means `current` is pointing to the node at `shiftStartsAt` position.
				Node<E> newHead = current.getNext();
				current.setNext(null);
				tail.setNext(head);
				
				return newHead;
			}
		}
    }
}











